# Interface DataProvider<K, D>

#### Type Parameters

- #### K

- #### D

#### Hierarchy

- EventTarget
  - DataProvider

#####
Index

### Methods

addEventListener
containsKeys
createOptimizedKeyMap?
createOptimizedKeySet?
dispatchEvent
fetchByKeys
fetchByOffset
fetchFirst
getCapability
getTotalSize
isEmpty
removeEventListener

## Methods

### addEventListener

- addEventListener(eventType, listener): void

- #### Parameters

  - ##### eventType: string

  - ##### listener: EventListener

  #### Returns void

  Overrides EventTarget.addEventListener

### containsKeys

- containsKeys(parameters): Promise<ContainsKeysResults<K>>

- #### Parameters

  - ##### parameters: FetchByKeysParameters<K>

  #### Returns Promise<ContainsKeysResults<K>>

### `Optional` createOptimizedKeyMap

- createOptimizedKeyMap(initialMap?): Map<K, D>

- #### Parameters

  - ##### `Optional` initialMap: Map<K, D>

  #### Returns Map<K, D>

### `Optional` createOptimizedKeySet

- createOptimizedKeySet(initialSet?): Set<K>

- #### Parameters

  - ##### `Optional` initialSet: Set<K>

  #### Returns Set<K>

### dispatchEvent

- dispatchEvent(evt): boolean

- #### Parameters

  - ##### evt: Event

  #### Returns boolean

  Overrides EventTarget.dispatchEvent

### fetchByKeys

- fetchByKeys(parameters): Promise<FetchByKeysResults<K, D>>

- #### Parameters

  - ##### parameters: FetchByKeysParameters<K>

  #### Returns Promise<FetchByKeysResults<K, D>>

### fetchByOffset

- fetchByOffset(parameters): Promise<FetchByOffsetResults<K, D>>

- #### Parameters

  - ##### parameters: FetchByOffsetParameters<D>

  #### Returns Promise<FetchByOffsetResults<K, D>>

### fetchFirst

- fetchFirst(parameters?): AsyncIterable<FetchListResult<K, D>, any, any>

- #### Parameters

  - ##### `Optional` parameters: FetchListParameters<D>

  #### Returns AsyncIterable<FetchListResult<K, D>, any, any>

### getCapability

- getCapability(capabilityName): any

- #### Parameters

  - ##### capabilityName: string

  #### Returns any

### getTotalSize

- getTotalSize(): Promise<number>

- #### Returns Promise<number>

### isEmpty

- isEmpty(): "unknown" | "yes" | "no"

- #### Returns "unknown" | "yes" | "no"

### removeEventListener

- removeEventListener(eventType, listener): void

- #### Parameters

  - ##### eventType: string

  - ##### listener: EventListener

  #### Returns void

  Overrides EventTarget.removeEventListener

Generated using TypeDoc